; CR3.ASM -- Virtual CR3 Device

	.386p

	INCLUDE VMM.INC

;*****************************************************************************
;		 			E Q U A T E S
;*****************************************************************************

;;; get your own ID from vxdid@microsoft.com
;;; is the formula below correct??

RUNNING_DOG_OEM		EQU	326
CR3_DEVICE_ID		EQU 2
CR3_VxD_ID			EQU (RUNNING_DOG_OEM SHL 5) OR CR3_DEVICE_ID
CFlag				EQU 1

;*****************************************************************************
;		 V I R T U A L	 D E V I C E   D E C L A R A T I O N
;*****************************************************************************

Declare_Virtual_Device CR3, 1, 0, CR3_VxD_Control, \
	CR3_VxD_ID, Undefined_Init_Order, \
	CR3_API_Handler, CR3_API_Handler,

;*****************************************************************************
;  			R E A L   M O D E   I N I T I A L I Z A T I O N
;*****************************************************************************

VXD_REAL_INIT_SEG

real_init proc near
	mov ah, 9
	mov dx, offset copyright
	int 21h
	xor ax, ax
	xor bx, bx
	xor si, si
	xor edx, edx
	ret
real_init endp

copyright	db	'CR3.386 -- CR3 Access VxD v. 1.0',0dh,0ah
			db	'Copyright (c) 1992 Andrew Schulman. All Rights Reserved.'
			db	0dh,0ah,'$'

VXD_REAL_INIT_ENDS

;*****************************************************************************
;  			L O C K E D   C O D E   S E G M E N T
;*****************************************************************************

VxD_LOCKED_CODE_SEG

BeginProc CR3_VxD_Control
	clc
	ret
EndProc CR3_VxD_Control

VxD_LOCKED_CODE_ENDS

;*****************************************************************************
;				O N L Y   D A T A   S E G M E N T
;*****************************************************************************

VxD_DATA_SEG

CR3_API_Call	label dword
				dd 	offset32 Get_Version
				dd	offset32 Get_CR3
				dd	offset32 Get_TLB

CR3_API_MaxCall EQU ( $ - CR3_API_Call ) / 4

VxD_DATA_ENDS

;*****************************************************************************
;          M O V E A B L E   C O D E   S E G M E N T
;*****************************************************************************

VxD_CODE_SEG

BeginProc	CR3_API_Handler
	movzx	eax, [ebp.Client_AX]
	cmp		eax, CR3_API_MaxCall		; Q: Is this a valid function?
	jae		SHORT CR3_API_Failed
	and		[ebp.Client_EFlags], NOT CFlag	; set up for success...!
	call	CR3_API_Call[eax * 4]
	ret
CR3_API_Failed:
	or		[ebp.Client_EFlags], CFlag
	ret
EndProc		CR3_API_Handler

BeginProc	Get_Version
	mov		[ebp.Client_AX], 0001h
	ret
EndProc		Get_Version

BeginProc	Get_CR3
	mov		eax, cr3
	mov		edx, eax
	shr		edx, 16
;;;	and		eax, 0FFFFh			;;; ???
	mov		[ebp.Client_DX], dx
	mov		[ebp.Client_AX], ax
	ret
EndProc		Get_CR3

BeginProc	Get_TLB
	mov		ax, [ebp.Client_DX]
	shl		eax, 16
	mov		ax, [ebp.Client_CX]
	mov		tr6, eax
	mov		eax, tr7
	mov		edx, eax
	shr		edx, 16
	mov		[ebp.Client_DX], dx
	mov		[ebp.Client_AX], ax
	ret
EndProc		Get_TLB

VxD_CODE_ENDS

	END
