/* 
DPMITEST.C -- Test for DPMISH
Andrew Schulman, February 1993
from "Undocumented DOS", 2nd edition (Addison-Wesley, 1993)

bcc -2 -DDPMI_APP dpmitest.c dpmish.c ctrl_c.asm
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <dos.h>
#include "dpmish.h"

void fail(const char *s) { puts(s); _dos_exit(1); }

void print_cs_ds(void)
{
	unsigned short dataseg, codeseg;
	_asm mov dataseg, ds
	_asm mov codeseg, cs
	printf("CS=%04X DS=%04X\n", codeseg, dataseg);
}

int real_main(int argc, char *argv[])
{
	printf("In real mode: ");
	print_cs_ds();
    return 0;   // okay to switch to protected mode
}

int pmode_main(int argc, char *argv[])
{
	printf("In prot mode: ");
	print_cs_ds();
	return 0;
}
