/* 
equiv.c

Write a program to determine whether the propositions
(p->q)-> and p->(q->r)are logically equivalent,
by constructing a truth table.
Note: p, q, and r are arbitrary propositions.

Andrew Schulman
3 February 1989

compile with: cl equiv.c
*/

#include <stdio.h>

#define IMPLIC(x,y)         ((!(x)) || (y))
#define EQUIV(x,y)          ((x) == (y))        /* same as x<->y */

#define FALSE               0
#define TRUE                1

#define TF(x)               ((x) ? 'T' : 'F')

typedef unsigned BOOL;

main()
{
    BOOL p, q, r, s;
	BOOL equiv = TRUE;		/* may be set to FALSE within loop */

    printf("p \tq \tr \t((p->q)->r)<->(p->(q->r))\n");
    printf("- \t- \t- \t-------------------------\n");
    
    for (p = FALSE; p <= TRUE; p++)
        for (q = FALSE; q <= TRUE; q++)
            for (r = FALSE; r <= TRUE; r++)
            {
                s = EQUIV(IMPLIC(IMPLIC(p,q),r), IMPLIC(p,IMPLIC(q,r)));
                if (! s)
                    equiv = FALSE;
                printf("%c \t%c \t%c \t\t%c\n", TF(p), TF(q), TF(r), TF(s));
            }
    
    puts(equiv ? "\nEquivalent" : "\nNot equivalent");
}

/*
output:

p   q   r   ((p->q)->r)<->(p->(q->r))
-   -   -   -------------------------
F   F   F       F
F   F   T       T
F   T   F       F
F   T   T       T
T   F   F       T
T   F   T       T
T   T   F       T
T   T   T       T

Not equivalent
*/
