/*
extract.c

12/10/92 (1.01): converted to C++, found bug in call to strncmp

Modify to take _list_ of offset-size/stop

FIX BUG:  TAKE .EXE AS OPTIONAL
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <io.h>
#include <fcntl.h>
#define __MSC
#include <dos.h>

#define BLOCKSIZE	10240

#define lmin(x,y)	(((x) < (y)) ? (x) : (y))

void fail(char *s) { puts(s); exit(1); }

char *usage = "extract <filename> "
              "<[0x]offset> <[0x]size or -[0x]size or -stop> <newfile>";

unsigned long aton(char *s)
{
	if ((s[0] == '0') && (s[1] == 'x'))
	{
		unsigned long ret;
		sscanf(&s[2], "%lx", &ret);
		return ret;
	}
	else
		return atol(s);
}
		
void extract(int src, int dst, unsigned long offset, unsigned size);

main(int argc, char *argv[])
{
	char *srcname, *dstname;
	unsigned long offset, size;
	signed long ofs;
	int src, dst;
	
#ifdef BOOK	
	fputs("File Extraction Utility version 1.01\n", stderr);
#else
	fputs("Windows Source File Extraction Utility version 1.01\n", stderr);
	fputs("Copyright (c) 1992 V Communications Inc.  All rights reserved.\n",
		stderr);
#endif
	fputs("Copyright (c) 1992 Andrew Schulman.  All rights reserved.\n\n",
		stderr);
	
	if (argc < 5)
		fail(usage);
		
	srcname = argv[1];
	ofs = offset = aton(argv[2]);
	if (argv[3][0] == '-')
	{
		char *s = &argv[3][1];
		if ((strncmp(s, "STOP", 4) == 0) || (strncmp(s, "stop", 4) == 0))
			size = -1;					// to end of file
		else
			size = aton(s) - offset;	// range
	}
	else if (! (size = aton(argv[3])))	// number of bytes
		fail(usage);
	dstname = argv[4];

#if 0	
	printf("extract %s %lu %lu %s\n", srcname, offset, size, dstname);
#endif
	
	if ((src = _open(srcname, O_RDONLY | O_BINARY)) == 0)
		fail("can't find file");
	if ((dst = _creat(dstname, _A_NORMAL)) == 0)
		fail("can't create target file");
	
	if (ofs < 0)
		offset = filelength(src) + ofs;	// offset from end of file
	
	if (size == -1)
		size = filelength(src) - offset;	// rest of file

	extract(src, dst, offset, size);
	
	_close(src);
	_close(dst);
	
	return 0;
}

void extract(int src, int dst, unsigned long offset, unsigned size)
{
	static unsigned char *buf = (unsigned char *) 0;
	unsigned long i;
	
	if (! buf)	// one-time initialization
	if (! (buf = (unsigned char *) malloc(BLOCKSIZE)))
		fail("insufficient memory");
	
	if (lseek(src, offset, SEEK_SET) == -1L)
		fail("invalid offset");
	
	for (i = 0; i < size; i += BLOCKSIZE)
	{
		unsigned rc, wc;
		unsigned blocksize = 
			(unsigned) lmin((unsigned long) BLOCKSIZE, size-i);
		if ((rc = _read(src, buf, blocksize)) == 0)
			fail("error reading");
		if ((wc = _write(dst, buf, rc)) == 0)
			fail("error writing");
		if (rc < blocksize)
			break;
		else if (wc < blocksize)
			fail("error writing");
	}
}

	
