/* 
FUNC0E32.C -- take over INT 21h Function 0Eh; return 32 in AL
cl -G2 func0e32.c
(Need -G2 or bcc -2 for PUSHA/POPA instructions)
*/

#include <stdlib.h>
#include <stdio.h>
#include <process.h>
#include <dos.h>

#pragma pack(1)

typedef struct {
#ifdef __TURBOC__
    unsigned short bp,di,si,ds,es,dx,cx,bx,ax;
#else
    unsigned short es,ds,di,si,bp,sp,bx,dx,cx,ax;  /* same as PUSHA */
#endif
    unsigned short ip,cs,flags;
    } REG_PARAMS;

void _interrupt _far dos(REG_PARAMS r);

void (_interrupt _far *old)(void);
static unsigned long calls = 0;
static unsigned long changed = 0;

void fail(char *s) { puts(s); exit(1); }

main(int argc, char *argv[])
{
	#define PROGNAME	"FUNC0E32"
	#define DESC		"Simulate Novell NetWare handling of INT 21h Func 32h"
	#define AUTHOR		"Andrew Schulman"
	#include "..\banner"
	
    if (argc < 2)
        fail("usage: func0e32 [program name] <args...>");
    
    old = (void (interrupt far *)(void)) _dos_getvect(0x21);
    _dos_setvect(0x21, dos);            /* hook INT 21h */

    if (spawnvp(P_WAIT, argv[1], &argv[1]) == -1) /* run command */
		puts("Can't run program!");
    
    _dos_setvect(0x21, old);            /* unhook INT 21h */

    printf("\n%lu DOS calls\n", calls);
    printf("%lu changed\n", changed);
    return 0;
}

void _interrupt _far dos(REG_PARAMS r)
{
    _asm pusha
    calls++;
    if ((r.ax >> 8) == 0x0E)  /* if Function 0Eh... */
    {
        _asm popa
        (*old)();             /* first call old INT 21h handler */
        r.ax = 0x0E20;        /* then force #drives to 20h (32) */
        changed++;
    }
    else                      /* not for us */
    {
        _asm popa
        _chain_intr(old);     /* pass to old INT 21h handler */
    }
}
