/*
FWORD.C
Win32 app -- demonstrates Win32->Win16 thunking via CALL FWORD PTR
Uses INTSERV.EXE (Win16 app)

from Schulman, Unauthorized Windows, 1994
*/

#include <stdlib.h>
#include <stdio.h>
#include "windows.h"

void fail(const char *s) { puts(s); exit(1); }

#pragma pack(1)

typedef struct {
	unsigned long ofs;
	unsigned short seg;
	} fword; 

int PASCAL WinMain(HANDLE hInstance, HANDLE hPrevInstance, 
    LPSTR lpCmdLine, int nCmdShow)
{
	// Microsoft C code per MSJ, May 1991, pp. 135-6
	#define argc __argc
	#define argv __argv

	extern int __argc;
	extern char **__argv;
	
	char buf[80];
	fword addr;
	unsigned reax, rebx, recx, redx;
	int i;
	
	sscanf(argv[1], "%04X:%08lX", &addr.seg, &addr.ofs);
	sscanf(argv[2], "%08lX/%08lX/%08lX/%08lX", 
		&reax, &rebx, &recx, &redx);
	
	sprintf(buf, "Calling %04X:%08lX %08lX/%08lX/%08lX/%08lX",
		addr.seg, addr.ofs, reax, rebx, recx, redx);
	MessageBox(0, buf, "FWORD", MB_OK);
	
	for (i=0; i<1000; i++) {
		_asm mov eax, reax
		_asm mov ebx, rebx
		_asm mov ecx, recx
		_asm mov edx, redx
		_asm call fword ptr [addr]
		_asm mov reax, eax
		_asm mov rebx, ebx
		_asm mov recx, ecx
		_asm mov redx, edx
	}
	
	sprintf(buf, "Returned %08lX/%08lX/%08lX/%08lX",
		reax, rebx, recx, redx);
	MessageBox(0, buf, "FWORD", MB_OK);
	
	return 0;
}

