/* 
IRQINT.C
Call VPICD_Convert_IRQ_To_Int
Andrew Schulman, April 1994
*/

#include <stdlib.h>
#include <stdio.h>
#include "prot.h"
#include "vxdcalls.h"

void fail(const char *s)           { puts(s); exit(1); }

int VPICDConvertIRQToInt(DWORD vm, int irq)
{
	VxDParams p;
	p.InEAX = irq;
	p.InEBX = vm;
	p.CallNum = VPICD_Convert_IRQ_To_Int;
	VxDCall(&p);
	return (p.OutEFLAGS & 1) ? -1 : p.OutEAX;
}

DWORD GetSysVMHandle(void)
{
    VxDParams p;
    p.CallNum = Get_Sys_VM_Handle;
    return (VxDCall(&p)) ? p.OutEBX : 0;
}

DWORD GetCurVMHandle(void)
{
    VxDParams p;
    p.CallNum = Get_Cur_VM_Handle;
    return (VxDCall(&p)) ? p.OutEBX : 0;
}

main()
{
	DWORD sys_vm = GetSysVMHandle();
	DWORD cur_vm = GetCurVMHandle();
	int irq, sys_intno, cur_intno;
	for (irq=0; irq<=0x0f; irq++)
	{
		sys_intno = VPICDConvertIRQToInt(sys_vm, irq);
		cur_intno = VPICDConvertIRQToInt(cur_vm, irq);
		printf("IRQ %d\t", irq);
		
		if (sys_intno == -1) printf("error\t");
		else printf("INT %02Xh\t", sys_intno);
		
		if (cur_intno == sys_intno) printf("\n");
		else if (cur_intno == -1) printf("error\n");
		else printf("INT %02Xh\n", cur_intno);
	}
	return 0;
}
