/* 
IS_SHARE.C -- Determine if SHARE really loaded
Also, fiddle with DR DOS SHARE
Andrew Schulman, April 1993
From "Undocumented DOS", 2nd edition (Addison-Wesley, 1993)
*/

#include <stdlib.h>
#include <stdio.h>
#include <dos.h>

int bogus_share(void)
{
	_asm mov ax, 1000h
	_asm int 2fh
	_asm cmp al, 0ffh
	_asm je supposedly_share
no_share:
	return 0;
supposedly_share:
	return 1;
}

int is_share(void)
{
	_asm push si
	_asm push di
	_asm xor bx, bx
	_asm mov cx, bx
	_asm mov dx, bx
	_asm mov si, bx
	_asm mov di, bx
	_asm mov ax, 5C00h		/* try to lock */
	_asm int 21h
	_asm jc lock_error
have_share:
	_asm mov ax, 5C01h		/* SHARE there: unlock! */
	_asm int 21h
	_asm pop di
	_asm pop si
	return 1;
lock_error:
	_asm pop di
	_asm pop si
	_asm cmp ax, 1			/* invalid function: no SHARE */
	_asm jne have_share_2:
no_share:
	return 0;
have_share_2:
	return 1;
}

int is_drdos_share(void)
{
	_asm mov ax, 4457h
	_asm mov dx, 0FFFFh
	_asm int 21h
	_asm jc no_dr_share
	_asm cmp ax, 4457h
	_asm jne have_dr_share
no_dr_share:
	return 0;
have_dr_share:;
	// return value in AX
}

void set_drdos_share(int flag)
{
	_asm mov ax, 4457h
	_asm mov dh, byte ptr flag
	_asm int 21h
}

main(int argc, char *argv[])
{
	if (argc > 1)
		set_drdos_share(atoi(argv[1]));
		
	if (is_drdos_share())
		puts("DR DOS SHARE loaded");
	
	if (bogus_share())
	{
		if (is_share())
			puts("SHARE loaded");
		else
			puts("SHARE supposedly loaded, but it really isn't");
	}
	else
	{
		if (! is_share())
			puts("SHARE not loaded");
		else
			puts("SHARE supposedly not loaded, but Func 5Ch present");
	}
	return 0;
}

