/*
PIFEXEC.C
Andrew Schulman, April 1993

Problems:

PIF structure in PIFSTRUC.H does not point to entire PIF file; just
        old portion.  Need one master PIF structure that includes all
        pieces typically found in a Windows 3.1 Enhanced mode PIF!
            
Need a define, like MAX_PIFFILE_SIZE, for this structure.

Is there a PIF "signature" that would enable one to write an IsPif()
function?
*/

#include <stdlib.h>
#include <string.h>
#include "windows.h"
#include "pifstruc.h"

BOOL ReadPif(char far *name, PIF far *fppif)
{
    HFILE f;
    UINT cb;
    
    if ((f = _lopen(name, READ)) == HFILE_ERROR)
        return FALSE;
    // should check that valid PIF etc.  need IsPif() function
    if ((cb = _lread(f, fppif, MAX_PIFFILE_SIZE)) == HFILE_ERROR)
        return FALSE;
    if (cb < PIFEX_OFFSET)  
        return FALSE;
    _lclose(f);
    return TRUE;
}

BOOL WritePif(char far *name, PIF far *fppif)
{
    HFILE f;
    UINT cb;
    
    if ((f = _lcreat(name, 0)) == HFILE_ERROR)
        return FALSE;
    if ((cb = _lwrite(f, fppif, MAX_PIFFILE_SIZE)) == HFILE_ERROR)
        return FALSE;
    if (cb < MAX_PIFFILE_SIZE)
        return FALSE;
    _lclose(f);
    return TRUE;
}

UINT PifExec(char far *name, BOOL background, BOOL windowed)
{
    PIF *ppif;
    UINT retval;
    char *pathname;
    
    if (! (pathname = (char *) malloc(256)))
        return FALSE;
    if (! (ppif = (PIF *) malloc(MAX_PIFFILE_SIZE)))
        return FALSE;
    GetWindowsDirectory(pathname, 256);
    strcat(pathname, "\\_default.pif");
    if (! ReadPif(pathname, ppif))    // have to look on path!
        return FALSE;
#if 0   
    // aarrghh!  how get to these?!?!
    ppif->flags_386.BackgroundON = background;
    ppif->flags_386.FullScreenYes = (! windowed);
#endif  
    lstrcpy(ppif->prog_path, name); // should check length
    if (! WritePif("__tmp.pif", ppif))
        return FALSE;
    retval = WinExec("__tmp.pif", SW_NORMAL);
    free(pathname);
    free(ppif);
    return retval;
}

int PASCAL WinMain(HANDLE hInstance, HANDLE hPrevInstance,
    LPSTR lpszCmdLine, int nCmdShow)
{
    PifExec(lpszCmdLine, 1, 1);
}
