// primes.c
// Andrew Schulman, July 1997
// andrew@ora.com (http://www.sonic.net/~undoc)
// For Web Review article, "Java on the Fly"

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <time.h>

#define MAXPR   1000000

void fail(const char *s) { puts(s); exit(1); }

unsigned calls = 0;

int divisable(int i, int aj) { calls++; return ((i % aj) == 0); }

main()
{
    int i, j;
    int numpr = 0;
    int intsqrt, aj;
    time_t startTime;
    int *array, *p;
    int incr;
    int per1, showstat;

    if (! (array = calloc(MAXPR, sizeof(int))))
        fail("Insufficient memory");

    array[0] = 2;
    array[1] = 3;
    array[2] = 5;
    numpr = 3;
    
    per1 = MAXPR / 100;
    showstat = per1;

    startTime = time(NULL);

    for (i=7, incr=2; numpr < MAXPR; i+=(incr=6-incr))
    {
        intsqrt = 1 + (int) sqrt(i);

        for (j=2, p=array+2; j<numpr; j++, p++)
        {
            if (divisable(i, aj = *p))
                break;
            else if (aj > intsqrt)
            {
                array[numpr++] = i;

                if (numpr == showstat)
                {
                    static int prevest = 0;
                    int sec = time(NULL) - startTime;
                    int percent = numpr / (MAXPR / 100);
                    int esttotalsec = (int) ((100.0 / (float) percent) * (float) sec);
                    int estremain = esttotalsec - sec;

                    if (prevest)
                    {
                        int diff = (estremain + sec) - prevest;
                        prevest = estremain + sec;
                        estremain += diff;
                    }
                    else
                        prevest = estremain + sec;

                    printf("%u\t%u\t%u\t%u\t%u\t%u\n",
                       percent, sec, i, calls, estremain, estremain + sec);

                    showstat += per1;
                }
                
                break;
            }
        }
    }

    printf("\n%u seconds\n", time(NULL) - startTime);
    //for (i=0; i<numpr; i++)
    //  printf("%u ", array[i]);
    printf("%u highest prime found\n", array[numpr-1]);
}
