/*
PROT.H
See PROT.C
Andrew Schulman, February 1993
from "Undocumented DOS", 2nd edition (Addison-Wesley, 1993)
*/

#ifndef _PROT_H
#define _PROT_H

#ifdef DPMI_APP
typedef int BOOL;
typedef unsigned char BYTE;
typedef unsigned short WORD;
typedef unsigned long DWORD;

#define LOWORD(dw)     ((WORD)(dw))
#define HIWORD(dw)     ((WORD)((DWORD)(dw) >> 16))
#else
#include "windows.h"
#endif

void far *map_real(void far *fp, DWORD size);
void set_base(DWORD b);
DWORD get_base(void);
void far *map_linear(DWORD lin_addr, DWORD num_bytes);
void free_mapped_linear(void far *fp);
WORD get_mapped(void);
void far *get_real_addr(void far *fp);
BOOL alloc_real_seg(DWORD bytes, WORD *ppara, WORD *psel);
BOOL free_real_seg(WORD sel);

#define free_mapped_real(x)     free_mapped_linear(x)

#ifndef MK_FP
#define MK_FP(seg, ofs) \
    ((void far *) (((unsigned long) (seg) << 16) | (ofs)))
#endif      

#define MK_LIN(fp) \
    (((DWORD) FP_SEG(fp) << 4) + FP_OFF(fp))

typedef struct {
    unsigned long edi, esi, ebp, reserved, ebx, edx, ecx, eax;
    unsigned flags, es, ds, fs, gs, ip, cs, sp, ss;
    } RMODE_CALL;
    
BOOL dpmi_rmode_intr(WORD intno, WORD flags, 
    WORD copywords, RMODE_CALL far *rmode_call);

int real_int86x(int intno, union REGS *inregs, union REGS *outregs,
    struct SREGS *sregs);
int real_int86(int intno, union REGS *inregs, union REGS *outregs);
int real_intdos(union REGS *inregs, union REGS *outregs);
int real_intdosx(union REGS *inregs, union REGS *outregs, 
    struct SREGS *sregs);

// to be defined by application;
// if DPMI_APP, app's fail() must call _dos_exit!
extern void fail(const char *s, ...);

#ifdef DPMI_APP
#define AllocSelector(x)        dpmi_alloc_selector()
#define FreeSelector(x)         dpmi_free_selector(x)
#define SetSelectorBase(x,y)    dpmi_set_selector_base((x), (y))
#define SetSelectorLimit(x,y)   dpmi_set_selector_limit((x), (y))
#define GetSelectorBase(x)      dpmi_get_selector_base(x)
#define GetSelectorLimit(x)     dpmi_get_selector_limit(x)
#define GlobalDosAlloc(x)       dpmi_dos_alloc(x)
#define GlobalDosFree(x)        dpmi_dos_free(x)

WORD dpmi_alloc_selector(void);
WORD dpmi_free_selector(WORD sel);
WORD dpmi_set_selector_base(WORD sel, DWORD base);
WORD dpmi_set_selector_limit(WORD sel, DWORD limit);
DWORD dpmi_get_selector_base(WORD sel);
DWORD dpmi_get_selector_limit(WORD sel);
DWORD dpmi_dos_alloc(DWORD bytes);
WORD dpmi_dos_free(WORD sel);
#endif
#endif
