/*
PSP.H -- Windows PSP structure

from "Undocumented Windows" by Schulman et al. (Addison-Wesley, 1992)
Chapter 5: KERNEL

Copyright (c) Andrew Schulman 1992
*/

#ifdef __cplusplus
extern "C" {
#endif

typedef struct _PSP
{
    WORD    signature;
    WORD    lastBlock;
    BYTE    r1;
    BYTE    dispatch[5];
    DWORD   int22;
    DWORD   int23;
    DWORD   int24;
    WORD    parent;
    BYTE    handles[20];
    WORD    environment;
    DWORD   saveStack;
    WORD    handleCount;
    DWORD   handleTablePtr;
    DWORD   sharePrevPSP;
    BYTE    r3[20];
    BYTE    int21Dispatch[3];
    BYTE    r4[9];
    BYTE    fcb1[16];
    BYTE    fcb2[16];
    DWORD   r5;
    BYTE    argLen;
    char    args[127];
}PSP;


#ifdef __cplusplus
}
#endif

