/* 
PSPTEST.C
Andrew Schulman, May 1993
From Undocumented DOS, 2nd edition (Addison-Wesley, 1993)
*/

#include <stdlib.h>
#include <stdio.h>
#include <dos.h>

#ifndef MK_FP
#define MK_FP(seg, ofs) \
    ((void far *) (((unsigned long) (seg) << 16) | (ofs)))
#endif      

typedef unsigned char BYTE;
typedef unsigned short WORD;

#pragma warn -rvl
WORD _dos_getpsp(void)
{
    _asm mov ah, 51h
    _asm int 21h
    _asm mov ax, bx
}

void _dos_setpsp(WORD psp)
{
    _asm mov bx, word ptr psp
    _asm mov ah, 50h
    _asm int 21h
}

#pragma warn -rvl
WORD _dos_getds(void)
{
    _asm mov ah, 52h
    _asm int 21h
    _asm mov ax, es
    // ignore SysVars offset in BX
}

void fail(const char *s) { puts(s); exit(1); }

main()
{
    BYTE far *dos_ds;
    WORD far *curr_psp_ptr;
    WORD psp;
    
    dos_ds = (BYTE far *) MK_FP(_dos_getds(), 0);
    switch (dos_ds[4])
    {
        case 0:  curr_psp_ptr = (WORD far *) (dos_ds + 0x02DE); break;
        case 1:  curr_psp_ptr = (WORD far *) (dos_ds + 0x0330); break;
        default: puts("DOS_DS[4] > 1"); goto okay;
    }
    
    psp = _dos_getpsp();
    if (*curr_psp_ptr != psp)
        fail("Curr_PSP field wrong!");
    
    _dos_setpsp(0);
    if (*curr_psp_ptr != 0)
    {
        _dos_setpsp(psp);
        fail("SetPSP(0) test failed");
    }
    
    _dos_setpsp(-1);
    if (*curr_psp_ptr != -1)
    {
        _dos_setpsp(psp);
        fail("SetPSP(-1) test failed");
    }

    _dos_setpsp(psp);
    puts("SetPSP(0) and SetPSP(-1) tests succeeded");
okay:
    return 0;
}
