/*
SFTWALK.C -- Count FILES= by Walking SFTs
For protected-mode Windows version, see \UNDOC2\CHAP3\SFTWALK.C
Andrew Schulman, March 1993
From "Undocumented DOS", 2nd edition (Addison-Wesley, 1993)
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <dos.h>

typedef unsigned char BYTE;
typedef unsigned short WORD;

typedef struct _sft {
    struct _sft far *next;
    WORD num;
    // the actual SFT entires start here
    } SFT;

int sftwalk(int offset, char *name)
{
    static BYTE far *sysvars = (BYTE far *) 0;
    SFT far *sft;
    int files = 0;
    if (! sysvars) 
    {
        _asm mov ah, 52h
        _asm int 21h
        _asm mov word ptr sysvars+2, es
        _asm mov word ptr sysvars, bx
        if (! sysvars) return 0;
    }
    sft = *((SFT far * far *) &sysvars[offset]);

    while (FP_OFF(sft) != 0xFFFF)
    {
        files += sft->num;
        printf("%s @ %Fp -- %u files\n", name, sft, sft->num);
        sft = sft->next;
    }
    return files;
}

main()
{
    int files, fcbs;
    files = sftwalk(4, "SFT");
    printf("FILES=%d\n\n", files);
#ifdef DO_FCBS
    fcbs = sftwalk(0x1A, "System FCB table");
    printf("FCBS=%d\n", fcbs);
#endif
    return files;
}
