/* 
TASKDB.H -- Task Database structure

from "Undocumented Windows" by Schulman et al. (Addison-Wesley, 1992)
Chapter 5: KERNEL

Copyright (c) Andrew Schulman, 1992
*/

#ifdef __cplusplus
extern "C" {
#endif

typedef struct
{
    WORD    next;                   // 0
    DWORD   sssp;                   // 2
    WORD    nevents;                // 6
    WORD    priority;               // 8
    WORD    unknown1;               // A
    WORD    hTask;                  // C
    WORD    unknown2[3];            // E
    WORD    fpcw;                   // 14
    WORD    flags;                  // 16
    WORD    errmode;                // 18
    WORD    expWinVer;              // 1A
    WORD    hInstance;              // 1C
    WORD    hModule;                // 1E
    WORD    hQueue;                 // 20
    WORD    hParent;                // 22
    WORD    SetSigHandlerFlag;      // 24
    DWORD   SetSigHandlerProc;      // 26
    DWORD   signalProc;             // 2A
    DWORD   gdiscardProc;           // 2E
    DWORD   int0Proc;               // 32
    DWORD   int2Proc;               // 36
    DWORD   int4Proc;               // 3A
    DWORD   int6Proc;               // 3E
    DWORD   int7Proc;               // 42
    DWORD   int3EProc;              // 46
    DWORD   int75Proc;              // 4A
    DWORD   Comptability;           // 4E
    char    unknown4[0x0E];         // 52
    WORD    pdb;                    // 60
    DWORD   dta;                    // 62
    BYTE    currDrive;              // 66
    char    currDir[0x43];          // 67
    WORD    directedYieldHTask;     // AA
    WORD    libraryListSeg;         // AC
    WORD    libraryListOffset;      // AE
    WORD    codeAlias;              // B0
    WORD    moreProcThunks;         // B2
    WORD    procThunksSig;          // B4
    WORD    unknown6;               // B6
    WORD    nextAvailableThunk;     // B8
    char    procThunkData[0x38];    // BA
    char    moduleName[8];          // F2
    WORD    signature;              // FA
} TASK_DB;

#ifdef __cplusplus
}
#endif

