/* 
TESTHAND.C -- test driver for HANDLES.H, HANDLES.C
from "Undocumented Windows" by Schulman et al. (Addison-Wesley 1992)
Chapter 5: KERNEL
*/

#include <stdlib.h>
#include <assert.h>
#include "windows.h"
#include "winio.h"
#include "handles.h"

main()
{
	extern HANDLE __hInst;	// in ARGCARGV.C
	HANDLE hTask, hModule, hModule2, hInstance, PSP;
	
	printf("Windows %d.%02d %s mode (%s)\n",
		LOBYTE(GetVersion()), HIBYTE(GetVersion()),
		(GetWinFlags() & WF_STANDARD) ? "Standard" : "Enhanced",
		(GetSystemMetrics(SM_DEBUG)) ? "DEBUG" : "RETAIL");
	
	hTask = GetCurrentTask();
	printf("hTask = %04x\n", hTask);
	
	hInstance = HINSTANCE_FROM_HTASK(hTask);
	printf("hInstance = %04x\n", hInstance);
	assert(hInstance == __hInst);
	
	hModule = HMODULE_FROM_HTASK(hTask);
	hModule2 = HMODULE_FROM_HINSTANCE(hInstance);
	printf("hModule = %04x\n", hModule);
	assert(hModule == hModule2);
	
	PSP = PSP_FROM_HTASK(hTask);
	printf("PSP = %04x\n", PSP);
	assert(PSP == GetCurrentPDB());
	
	assert(hTask_from_hInstance(hInstance) == hTask);
	assert(PSP_FROM_HINSTANCE(hInstance) == PSP);
	assert(hTask_from_PSP(PSP) == hTask);
	assert(HINSTANCE_FROM_PSP(PSP) == hInstance);
		
	return 0;
}

