/*
MEM1.C -- walks DOS MCB chain(s): simple version
Andrew Schulman and Jim Kyle, July 1990
	 revised by Jim Kyle, August 1992
*/

#include <stdlib.h>
#include <stdio.h>
#include <dos.h>

#include "undocdos.h"

void fail(char *s) { puts(s); exit(1); }

LPMCB get_mcb(void)
{
    ASM mov ah, 52h
    ASM int 21h
    ASM mov dx, es:[bx-2]
    ASM xor ax, ax
    /* in both Microsoft C and Turbo C, far* returned in DX:AX */
}

void display(LPMCB)
{
    char buf[80];
    sprintf(buf, "%04X    %04X    %04X (%6lu)",
	FP_SEG(mcb), mcb->owner, mcb->size, (long) mcb->size << 4);
    if (! mcb->owner)
	strcat(buf, "   free");
    puts(buf);
}

void walk(LPMCB)
{
    printf("Seg     Owner   Size\n");
    for (;;)
	switch (mcb->type)
	{
	    case 'M' : /* Mark : belongs to MCB chain */
		display(mcb);
		mcb = (LPMCB)MK_FP(FP_SEG(mcb) + mcb->size + 1, 0);
		break;
	    case 'Z' : /* Zbikowski : end of MCB chain */
		display(mcb);
		printf("%04X\n", FP_SEG(mcb) + mcb->size + 1);
		return;
	    default :
		fail("error in MCB chain");
	}
}

main(int argc, char *argv[])
{
    walk(get_mcb());
    return 0;
}
