; UNDOCMGR.ASM 
; Sample VxD that provides two undocumented DOS functions in protected mode
; Andrew Schulman, April 1993
; From "Undocumented DOS", 2nd edition (Addison-Wesley, 1993)

.386p

INCLUDE VMM.INC
INCLUDE V86MMGR.INC

;*****************************************************************************
;        V I R T U A L   D E V I C E   D E C L A R A T I O N
;*****************************************************************************

Declare_Virtual_Device UNDOSMGR, 1, 0, \
    Control_Proc, \
    Undefined_Device_ID, \
    Undefined_Init_Order, , ,\

;*****************************************************************************
;               O N L Y   D A T A   S E G M E N T
;*****************************************************************************

VxD_DATA_SEG

Prev_Int21Pmode     dd  0
Prev_Int21Pmode_Seg dw  0

VxD_DATA_ENDS

;*****************************************************************************
;          M O V E A B L E   C O D E   S E G M E N T
;*****************************************************************************

VxD_CODE_SEG

BeginProc   Int21Pmode
    mov     eax, [ebp.Client_EAX]
    cmp     ah, 60h
    je      short Do_Truename
    cmp     ax, 5D06h
    je      short Do_GetSDA

Default:
    movzx   ecx, Prev_Int21Pmode_Seg    ;; *NOT* mov cx!!
    mov     edx, Prev_Int21Pmode
    VMMcall Simulate_Far_Jmp
    jmp     short Fini

Do_Truename:
    VMMcall Simulate_Iret
    mov     edx, OFFSET32 TrueName_API
    VxDcall V86MMGR_Xlat_API
    jmp     short Fini

Do_GetSDA:

IFDEF BYPASS_V86MMGR
    ; sample code to show how this looks with raw VMM calls
    VMMcall Simulate_Iret
    VMMcall Begin_Nest_V86_Exec
    mov     eax, 21h
    VMMcall Exec_Int                ; reflect INT 21h to V86 mode
    VMMcall Resume_Exec             ; do it now!
    movzx   eax, [ebp.Client_DS]    ; get V86 DS inside nest
    VMMcall End_Nest_Exec
    shl     eax, 4                  ; make linear address
    mov     ecx, 0FFFFh             ; 64k segment
    VMMcall Map_Lin_To_VM_Addr      ; create permanent selector
    mov     [ebp.Client_DS], cx     ; return selector to caller in DS
ELSE
    VMMcall Simulate_Iret
    mov     edx, OFFSET32 GetSDA_API
    VxDcall V86MMGR_Xlat_API
ENDIF

Fini:
    clc
    ret

TrueName_API:
    ; need comment
    Xlat_API_ASCIIZ ds, si      ; source
    Xlat_API_ASCIIZ es, di      ; dest
    Xlat_API_Exec_Int 21h

GetSDA_API:
    ; need coment
    Xlat_API_Return_Ptr DS, SI
    Xlat_API_Exec_Int 21h
EndProc     Int21Pmode

VxD_CODE_ENDS

;*****************************************************************************
;           L O C K E D   C O D E   S E G M E N T
;*****************************************************************************

VxD_LOCKED_CODE_SEG

BeginProc   Control_Proc
    Control_Dispatch Device_Init, Do_Device_Init
    clc     
    ret
EndProc     Control_Proc

VxD_LOCKED_CODE_ENDS

;*****************************************************************************
;               P M   I N I T   C O D E   S E G M E N T
;*****************************************************************************

VxD_ICODE_SEG

BeginProc   Do_Device_Init
    ; get previous pmode INT 21h handler, so can chain
    mov     eax, 21h
    VMMcall Get_PM_Int_Vector
    mov     Prev_Int21Pmode, edx        ; offset
    mov     Prev_Int21Pmode_Seg, cx     ; segment

    ; turn Int21 handler into pmode callback
    xor     edx, edx
    mov     esi, OFFSET32 Int21Pmode
    VMMcall Allocate_PM_Call_Back
    jc      short Done
    ; segment:offset callback address in EAX

    ; install pmode Int21 handler
    mov     ecx, eax
    movzx   edx, ax
    shr     ecx, 10h
    mov     eax, 21h            ; eax = intno
    VMMcall Set_PM_Int_Vector
Done:
    clc
    ret
EndProc     Do_Device_Init

VxD_ICODE_ENDS

;*****************************************************************************
;           R E A L   M O D E   I N I T I A L I Z A T I O N
;*****************************************************************************

VXD_REAL_INIT_SEG

; just a stub real_init procedure
real_init proc near
    xor ax, ax
    xor bx, bx
    xor si, si
    xor edx, edx
    ret
real_init endp

VXD_REAL_INIT_ENDS

    END
