/* 
   VFAT26OK.C -- Tell VFAT.386 in WfW 3.11 that INT 26h writes
   are okay.  I have absolutely no idea how safe or unsafe this is!!!
       
   usage: vfat26ok [flag]
       
   Andrew Schulman 1/17/94
   CIS 76320,302
*/     
   
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <dos.h>

#define VFAT_VXD        0x486

void fail(const char *s) { puts(s); exit(1); }

typedef void (far *FUNCPTR)(void);

FUNCPTR GetVxDAPI(unsigned short vxd_id)
{
    _asm push di
    _asm mov ax, 1684h
    _asm mov bx, vxd_id
    _asm xor di, di
    _asm mov es, di
    _asm int 2fh
    _asm mov ax, di
    _asm mov dx, es
    _asm pop di
    // returns in DX:AX
}

char *usage = "usage: vfat26ok [flag (0=disable INT 26) (1=enable INT 26)]";

main(int argc, char *argv[])
{
    FUNCPTR vfat_api;
    int flag;
    
    if (argc < 2) 
        fail(usage);
    if (! isdigit(argv[1][0]))
        fail(usage);
    flag = atoi(argv[1]);
    
    // use INT 2Fh AX=1684h BX=486h to get callback to VFAT API
    if (! (vfat_api = GetVxDAPI(VFAT_VXD)))
        fail("VFAT is not installed!");
	
#define GET_STATS
#ifdef GET_STATS
{
	#pragma pack(1)
	typedef unsigned long DWORD;
	typedef struct {
		DWORD sign[2];	// sign[0] should be 3, sign[1] should be 0
		DWORD cache_size;
		DWORD LockRetryDelay, LockRetryCount;
		DWORD DataAge, DiskIdle;
		DWORD BufHold, DirCache;
		} VFAT_STATS;
	VFAT_STATS stats, far *fp = (VFAT_STATS far *) &stats;
	int size = sizeof(VFAT_STATS);
	_asm mov ax, 0
	_asm mov cx, word ptr size
	_asm les bx, dword ptr fp
	(*vfat_api)();
	_asm jc failure
	if ((stats.sign[0] != 3) || (stats.sign[1] != 0))
		fail("VFAT_STATS structure looks wrong!");
	printf("Cache size: %lu\n", stats.cache_size);
	#define PRINT_PROFILE(s)	printf("%s: %lu\n", #s, stats.s)
	PRINT_PROFILE(LockRetryDelay);
	PRINT_PROFILE(LockRetryCount);
	PRINT_PROFILE(DataAge);
	PRINT_PROFILE(DiskIdle);
	PRINT_PROFILE(BufHold);
	PRINT_PROFILE(DirCache);
	/* Can *change* these VFAT variables either using SYSTEM.INI
	   [386Enh] section, or with API #1 */
	return 0;
failure:
	fail("VFAT failed API call 0!");
}
#endif GET_STATS
    
    // call VFAT API #4 (set INT 26h flag)
    _asm mov ax, 4
    _asm mov bx, word ptr flag
    (*vfat_api)();
    _asm jc failure4
    return 0;
failure4:
    fail("VFAT failed API call 4!");
}
