comment~
VRamDrv -- Virtual device that implements a RamDrive as a network
	redirector.  This provides a ramdrive that occupies no memory
	in the first megabyte.

	The code that implements the ramdrive is written in C and
	is a translation of the "phantom.pas" program from the
	book "Undocumented DOS" by Schulman et al. 
	The ramdrive is a limited implementation, which supports
	only one file and one subdirectory.

This VxD does not support any VxD services.
This VxD does not support a realmode API.
This VxD does not support a protected mode API.
This VxD 's Control_Dispatch watches for a couple of messages.	
	Device_Init: Call VRamInit to create the driveletter and hook Int2F.
	System_Exit: (Windows normal or crash exit):  Clean up CDS. 
The	primary mission of this VxD is all done in the callback for Int2F, which 
	fields Int2F AH=11 calls that are made by DOS to access data
	via the Network Redirector interface.

Add device=VRamDrv.386 to SYSTEM.INI [386Enh]
~

.386p

INCLUDE VMM.INC
PUBLIC _Handle2F
EXTRN _Handle2F11:NEAR		;; C routine that services redirector interrupts
EXTRN _VRamInit:NEAR		;; C routine that sets up ramdrive at init time
EXTRN _VRamTerminate:NEAR	;; C routine that cleans up at Windows shutdown
;*****************************************************************************
;                   E Q U A T E S
;*****************************************************************************

verMaj            EQU 1
verMin            EQU 0
ver		       EQU ((verMaj SHL 8) OR verMin)

;*****************************************************************************
;        V I R T U A L   D E V I C E   D E C L A R A T I O N
;*****************************************************************************

Declare_Virtual_Device VRamDrv	\
			, verMaj			\
			, verMin			\
			,VRamDrv_VxD_Control\
			,Undefined_Device_ID	\
			,Undefined_Init_Order	;We don't care if we're last or first VxD


;*****************************************************************************
;           R E A L   M O D E   I N I T I A L I Z A T I O N
;*****************************************************************************

VXD_REAL_INIT_SEG
VXD_REAL_INIT_ENDS

;*****************************************************************************
;           L O C K E D   C O D E   S E G M E N T
;*****************************************************************************

VxD_LOCKED_CODE_SEG
BeginProc VRamDrv_VxD_Control
	Control_Dispatch Device_Init,   _VRamInit; Jump to C routine to do the work
	Control_Dispatch System_Exit,	_VRamTerminate; Jump to C rtn to do it.
	clc
	ret
EndProc VRamDrv_VxD_Control
BeginProc _Handle2F
	cmp [ebp.Client_AH],11h	;Q:Is it a redirector call (which might be ours?)
	je short AH11			;Y:Go service it.
	stc						;N:Tell the system that we did not service it.
	ret						;	Return control to the VMM
AH11:
	cmp [ebp.Client_AX],1123h;Q:Is it oft-issued redir call that is never ours?
	jne short OurAH11			;N:Not that call.  It might be ours; go check.
	stc							;Y: Cannot be ours.Tell VMM we did not service
	ret							;	Return to the VMM
OurAH11:
	push ebp				;Put ebp onto stack where C handler can get at it
	call _Handle2F11		;Service it if it's for one of our drives.
	ret
EndProc _Handle2F

VxD_LOCKED_CODE_ENDS

;*****************************************************************************
;                  D A T A   S E G M E N T
;*****************************************************************************

VxD_DATA_SEG
VxD_DATA_ENDS
;*****************************************************************************
;              I N I T I A L I Z A T I O N   ( 3 2 - B I T )
;*****************************************************************************
VxD_ICODE_SEG	 defines start of initialization code segment
VxD_ICODE_ENDS  defines end of initialization code segment
VxD_IDATA_SEG	 defines start of initialization data segment
VxD_IDATA_ENDS  defines end of initialization data segment

;*****************************************************************************
;          M O V E A B L E   C O D E   S E G M E N T
;*****************************************************************************

VxD_CODE_SEG
VxD_CODE_ENDS

    END

