/* 
VXDCALLS.H -- See VXDCALLS.C
Andrew Schulman, February 1993
From "Undocumented DOS", 2nd edition (Addison-Wesley, 1993)
Abbreviated from version in Microsoft Systems Journal, February 1993
*/

#ifdef DPMI_APP
typedef int BOOL;
typedef unsigned short WORD;
typedef unsigned long DWORD;
#endif

#ifndef FALSE
#define FALSE   0
#define TRUE    (! FALSE)
#endif

/* Structure used with VxDCall */
typedef struct {
    DWORD CallNum;
    DWORD Reserved1;
    DWORD InEAX, InEBX, InECX, InEDX, InEBP, InESI, InEDI;
    DWORD Reserved2, Reserved3;
    DWORD OutEAX, OutEBX, OutECX, OutEDX, OutEBP, OutESI, OutEDI;
    WORD  OutFS, OutGS;
    DWORD OutEFLAGS;
    } VxDParams;
    
/* Structure used with VxDPushCall */   
typedef struct {
    DWORD CallNum;
    DWORD NumP;
    DWORD P[10];
    DWORD OutEAX, OutEDX;
    } VxDPushParams;
    
#define CARRYFLAG           1
#define ZEROFLAG            (1 << 6)
#define OVERFLOWFLAG        (1 << 11)

/* VxD ID assigned by vxdid@microsoft.com */
#define Generic_Dev_ID      0x28c0

/* Functions supplied by VXD.386 */
#define VXD_Version         0
#define VXD_VxDCall         1
#define VXD_VxDPushCall     3

/* 
W3MAP.H is a boring file generated from w3map -verbose or awk vxddef.awk:
#define Get_VMM_Version     0x010000L
#define Get_Cur_VM_Handle   0x010001L
#define Test_Cur_VM_Handle  0x010002L
#define Get_Sys_VM_Handle   0x010003L
#define Test_Sys_VM_Handle  0x010004L
....
#define Call_When_Idle      0x01003AL
#define Get_Next_VM_Handle  0x01003BL
#define Set_Global_Time_Out 0x01003CL
...
etc.
*/
#include "w3map.h"

/* function calls */
typedef void (far *api_entry)(void);

api_entry GetVxDAPI(WORD vxd_id);
BOOL GenericVxDInstalled(void);
BOOL VxDCall(VxDParams far *fp);
BOOL VxDPushCall(VxDPushParams far *fp);
