/* 
VXDSHOW.C -- linear executable dumper

TODO:
	Need SYMDUMP program to do .sym files!!  TDUMP knows .sym files; use
	Matt P. article; most segments turn into seg_a.  But how to handle
	real-mode init segs?  Don't know where real-mode init starts??
	(DONE?)
*/		


#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <io.h>
#include <fcntl.h>
#include <share.h>
#include <dos.h>
#include "filelib.h"

/* lifted from MSoft newexe.h */
#define ENEWHDR     0x003CL         /* offset of new EXE header */
#define EMAGIC      0x5A4D          /* old EXE magic id:  'MZ'  */
#define NEMAGIC     0x454E          /* new EXE magic id:  'NE'  */
#define LEMAGIC		0x454C			/* linear executable */
#define LXMAGIC		0x584C			/* IBM OS/2 2.0 linear executable */
#define PEMAGIC		0x4550			/* NT portable executable */
#define W3MAGIC		0x3357			/* WIN386.EXE signature */
#define SZMAGIC		0x5A53			/* SZ -- compressed file */

void fail(char *s) { fputs("VXDSHOW fail: ", stdout); puts(s); exit(1); }

void fail_perror(void)	{ perror("VXDSHOW fail"); exit(1); }

void usage()
{
	puts("VXDSHOW displays information about a Windows 3+ Enhanced mode");
	puts("Virtual Device Driver (VxD), in a linear-executable (LE) file.");
	puts("");
	puts("To display information about a VxD:");
	puts("         VXDSHOW vxd_file");
	puts("example: VXDSHOW \\win31\\system\\vtdapi.386");
	exit(1);
}
	
void le(char *name);
void le2(unsigned long offset);

static unsigned long align;
int f;
unsigned long start_newexe;

main(int argc, char *argv[])
{
	int i;

	fputs("Linear Executable Dumper version 2.01a\n", stderr);
	fputs("Copyright (c) 1992-93 Andrew Schulman.  All rights reserved.\n\n", 
		stderr);
	
	if (argc < 2)
		usage();
	
	for (i=1; i<argc; i++)
		if ((argv[i][0] == '-') || (argv[i][0] == '/'))
		{
			if (argv[i][1] == '?')
				usage();
		}
		else
		{
			char buf[128];
			strcpy(buf, argv[i]);
			if (! strchr(buf, '.'))
				strcat(buf, ".386");
			le(buf);
		}
	return 0;
}

void le(char *name)
{
	unsigned long pos;
    unsigned short w;
	unsigned i;
	
	if ((f = sopen(name, O_RDONLY | O_BINARY, SH_DENYNO)) == -1)
		fail_perror();
	exe_read(f, &w, 0, 2);	// read first two bytes of file
    if (w != EMAGIC)
	{
		if (w == SZMAGIC)
			fail("compressed file (SZ) -- use EXPAND.EXE");
		else
			fail("not an executable");
	}
	exe_read(f, &w, 0x18, 2);
	if (w < 0x40)
		fail("not an LE (linear executable)");
	exe_read(f, &start_newexe, ENEWHDR, 4);
	exe_read(f, &w, start_newexe, 2);
	if (w == W3MAGIC)
		fail("use W3MAP to examine this WIN386 file");
	else if (w != LEMAGIC)
		fail("not an LE (linear executable)");
	le2(start_newexe);
	close(f);
}

#define DO_NRESTAB
#include "le2.c"

