/* WHMACROS.C -- Get macros from a .HLP file. Used by HELPDIR.C if #define
   DO_MACROS -- Pete Davis and Andrew Schulman,
   bcc -DDO_MACROS whmacros.c helpdir.c
   See "Undocumented Corner," DDJ, September 1993 */

#pragma pack(1)
#include <conio.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "whstruct.h"

extern void fail(const char *s);

#define PAGE_SIZE       1024L        /* 1k pages -- must be long! */

void do_macros(FILE *HelpFile, long WHIFSStart)
{
   BTREENODEHEADER  WHIFSNode;
   SYSTEMHEADER     SystemHdr;
   SYSTEMREC        SystemRec;
   FILEHEADER       FileHdr;
   unsigned long    SystemOffset=0, FileOffset, FileStart;
   char             filename[20], *data;
   int              *Offsets;
   int              c, i, file, txt;
   /* Find the System file. */
   do {
       fread(&WHIFSNode, sizeof(WHIFSNode) - 2, 1, HelpFile);
       /* Search all entries in node */
       for (file = 1; file <= WHIFSNode.NEntries; file ++) {
          i = 0;
          while ( c = fgetc(HelpFile) )
                filename[i++]=c;
          filename[i] = 0;
          fread(&FileOffset, sizeof(FileOffset), 1, HelpFile);
          if (strcmp(filename, "|SYSTEM") == 0) {
              SystemOffset = FileOffset;
              break;
          }
       }
       if (WHIFSNode.NextPage != -1)
          fseek(HelpFile, WHIFSStart + (WHIFSNode.NextPage * PAGE_SIZE),
              SEEK_SET);
   } while (WHIFSNode.NextPage != -1);
    if (! SystemOffset)
        fail("Can't locate |SYSTEM file");
   /* Get System header */
   fseek(HelpFile, SystemOffset, SEEK_SET);
   fread(&FileHdr, sizeof(FileHdr), 1, HelpFile);
   fread(&SystemHdr, sizeof(SystemHdr), 1, HelpFile);

   FileStart = SystemOffset + sizeof(FileHdr) + sizeof(SystemHdr);
   FileOffset = 0;
   while (FileOffset < FileHdr.FileSize)    {
       fseek(HelpFile, FileStart + FileOffset, SEEK_SET);
       fread(&SystemRec, sizeof(SystemRec)-1, 1, HelpFile);
       FileOffset += (sizeof(SystemRec) + SystemRec.DataSize - 1);
       if (SystemRec.RecordType == MACRO_DATA)  {
           if (! (data = (char *) malloc(SystemRec.DataSize+1)))
               fail("insufficient memory");
           fread(data, SystemRec.DataSize, 1, HelpFile);
           data[SystemRec.DataSize] = '\0';
           printf("%s\n\n", data);
           free(data);
       }
   }
}
