/*
WINSIZE.C -- Show various Windows "sizes"
Andrew Schulman
Microsoft Systems Journal, March 1993

-- instructions for 16-bit
-- instructions for 32-bit
*/

#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include "windows.h"

static char buf[1024] = {0};
static char title[64] = {0};

#define print(str, x) { \
	char tmp[128]; \
	wsprintf(tmp, (str), (x)); \
	strcat(buf, tmp); \
	}

int PASCAL WinMain(HANDLE hInstance, HANDLE hPrevInstance, 
    LPSTR lpCmdLine, int nCmdShow)
{
	HANDLE h;
	WORD wVers;
	print("sizeof(int) = %d\n", sizeof(int));
	print("sizeof(size_t) = %d\n", sizeof(size_t));
	print("sizeof(HANDLE) = %d\n", sizeof(HANDLE));
	print("sizeof(void near *) = %d\n", sizeof(void near *));
	print("GlobalAlloc = %X\n", h = GlobalAlloc(GMEM_MOVEABLE, 1024));
	print("GlobalLock = %08lX\n", GlobalLock(h));
	print("LocalAlloc = %X\n", h = LocalAlloc(LMEM_MOVEABLE, 1024));
	print("LocalLock = %X\n", LocalLock(h));
	print("malloc = %X\n", malloc(1024));
	print("Typical API function pointer = %08lX\n", GetVersion);
	wVers = GetVersion();
	wsprintf(title, "WINSIZE (%d Bits) - Windows %d.%02d", 
		sizeof(int) * CHAR_BIT,
		LOBYTE(wVers), HIBYTE(wVers));
	MessageBox(0, buf, title, MB_OK);
	return 0;
}


